﻿using System;
using System.Collections;
using System.Runtime.InteropServices;

public class MyClass<T> where T : ICollection
{
}

public class MyType<T> where T : ICollection, IConvertible
{
}

public class Dict<K, V>
    where K : ICollection
    where V : IComparable
{
}

public class Utility
{
    public static void WriteLog<T>(T item)
    {
        string output = string.Format("{0}: {1}", DateTime.Now, item);
        Console.WriteLine(output);
    }

    public static T Max<T>(T item1, T item2) where T : IComparable
    {
        if (item1.CompareTo(item2) >= 0)
        {
            return item1;
        }

        return item2;
    }

    public static int GetSizeOf<T>(T item) where T : struct
    {
        return Marshal.SizeOf(item);
    }

    public static void CheckNull<T>(T item) where T : class
    {
        if (item == null)
        {
            throw new ArgumentNullException();
        }
    }
 
    public static T AllocateIfNull<T>(T item) where T : class, new()
    {
        if (item == null)
        {
            item = new T();
        }

        return item;
    }

    public static T Allocate<T, V>() where V : T, new()
    {
        return new V();
    }
}

public class BaseClass { }

public class DerivedClass : BaseClass { }

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            Utility.WriteLog(true);
            Utility.WriteLog(0x05);
            Utility.WriteLog(3.14159f);
            Utility.WriteLog("test");

            Utility.WriteLog<bool>(true);
            Utility.WriteLog<int>(0x05);
            Utility.WriteLog<float>(3.14159f);
            Utility.WriteLog<string>("test");

            Console.WriteLine(Utility.Max(5, 6)); // 출력결과: 6
            Console.WriteLine(Utility.Max("Abc", "def")); // 출력결과: def

            Console.WriteLine(Utility.GetSizeOf(0.5f));
            Console.WriteLine(Utility.GetSizeOf(4m));

            // 아래의 코드는 컴파일 시에 오류 발생
            // Console.WriteLine(Utility.GetSizeOf("test"));

            // 아래의 코드는 컴파일 시에 오류 발생
            // int a = 5;
            // Utility.CheckNull(a);

            string b = "My";
            Utility.CheckNull(b);

            BaseClass dInst = new DerivedClass();

            BaseClass dInst2 = Utility.Allocate<BaseClass, DerivedClass>();
        }
    }
}